Whamcloud - gitweb
LU-4512 hsm: Fix lhsmtool_posix --report option
[fs/lustre-release.git] / lustre / tests / sanity-hsm.sh
old mode 100644 (file)
new mode 100755 (executable)
index 5209cab..f535b7e
@@ -11,12 +11,11 @@ SRCDIR=$(dirname $0)
 export PATH=$PWD/$SRCDIR:$SRCDIR:$PWD/$SRCDIR/utils:$PATH:/sbin:/usr/sbin
 
 ONLY=${ONLY:-"$*"}
-# bug number for skipped test:
+# bug number for skipped test:    3815
+ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 34 35 36"
+# bug number for skipped test:4178         4176
+ALWAYS_EXCEPT="$ALWAYS_EXCEPT 200 221 223b 31a"
 # UPDATE THE COMMENT ABOVE WITH BUG NUMBERS WHEN CHANGING ALWAYS_EXCEPT!
-# skip test cases failed before landing - Jinshan
-
-ALWAYS_EXCEPT="$SANITY_HSM_EXCEPT 12a 12b 12n 13 30a 31a 34 35 36"
-ALWAYS_EXCEPT="$ALWAYS_EXCEPT 110a 200 201 221 222a 223a 223b 225"
 
 LUSTRE=${LUSTRE:-$(cd $(dirname $0)/..; echo $PWD)}
 
@@ -31,9 +30,9 @@ MCREATE=${MCREATE:-mcreate}
 MOUNT_2=${MOUNT_2:-"yes"}
 FAIL_ON_ERROR=false
 
-if [[ $MDSCOUNT -ge 2 ]]; then
-       skip_env "Only run with single MDT for now" && exit
-fi
+# script only handles up to 10 MDTs (because of MDT_PREFIX)
+[ $MDSCOUNT -gt 9 ] &&
+       error "script cannot handle more than 9 MDTs, please fix" && exit
 
 check_and_setup_lustre
 
@@ -91,12 +90,14 @@ init_agt_vars() {
 
        export HSMTOOL=${HSMTOOL:-"lhsmtool_posix"}
        export HSMTOOL_VERBOSE=${HSMTOOL_VERBOSE:-""}
+       export HSMTOOL_UPDATE_INTERVAL=${HSMTOOL_UPDATE_INTERVAL:=""}
        export HSMTOOL_BASE=$(basename "$HSMTOOL" | cut -f1 -d" ")
        HSM_ARCHIVE=$(copytool_device $SINGLEAGT)
        HSM_ARCHIVE_NUMBER=2
 
-       MDT_PARAM="mdt.$FSNAME-MDT0000"
-       HSM_PARAM="$MDT_PARAM.hsm"
+       # The test only support up to 10 MDTs
+       MDT_PREFIX="mdt.$FSNAME-MDT000"
+       HSM_PARAM="${MDT_PREFIX}0.hsm"
 
        # archive is purged at copytool setup
        HSM_ARCHIVE_PURGE=true
@@ -117,6 +118,22 @@ cleanup() {
        cdt_set_sanity_policy
 }
 
+get_mdt_devices() {
+       local mdtno
+       # get MDT device for each mdc
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               MDT[$idx]=$($LCTL get_param -n \
+                       mdc.$FSNAME-MDT000${idx}-mdc-*.mds_server_uuid |
+                       awk '{gsub(/_UUID/,""); print $1}' | head -1)
+       done
+}
+
+search_copytools() {
+       local agents=${1:-$(facet_active_host $SINGLEAGT)}
+       do_nodesv $agents "pgrep -x $HSMTOOL_BASE"
+}
+
 search_and_kill_copytool() {
        local agents=${1:-$(facet_active_host $SINGLEAGT)}
 
@@ -128,7 +145,7 @@ copytool_setup() {
        local facet=${1:-$SINGLEAGT}
        local lustre_mntpnt=${2:-$MOUNT}
        local arc_id=$3
-       local hsm_root=$(copytool_device $facet)
+       local hsm_root=${4:-$(copytool_device $facet)}
        local agent=$(facet_active_host $facet)
 
        if [[ -z "$arc_id" ]] &&
@@ -148,6 +165,8 @@ copytool_setup() {
        # independent of hardware
        local cmd="$HSMTOOL $HSMTOOL_VERBOSE --daemon --hsm-root $hsm_root"
        [[ -z "$arc_id" ]] || cmd+=" --archive $arc_id"
+       [[ -z "$HSMTOOL_UPDATE_INTERVAL" ]] ||
+               cmd+=" --update-interval $HSMTOOL_UPDATE_INTERVAL"
        cmd+=" --bandwidth 1 $lustre_mntpnt"
 
        # Redirect the standard output and error to a log file which
@@ -164,10 +183,34 @@ copytool_setup() {
 copytool_cleanup() {
        trap - EXIT
        local agents=${1:-$(facet_active_host $SINGLEAGT)}
+       local mdtno
+       local idx
+       local oldstate
+       local mdt_hsmctrl
 
        do_nodesv $agents "pkill -INT -x $HSMTOOL_BASE" || return 0
        sleep 1
        echo "Copytool is stopped on $agents"
+
+       # clean all CDTs orphans requests from previous tests
+       # that would otherwise need to timeout to clear.
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               idx=$(($mdtno - 1))
+               mdt_hsmctrl="mdt.$FSNAME-MDT000${idx}.hsm_control"
+               oldstate=$(do_facet mds${mdtno} "$LCTL get_param -n " \
+                                  "$mdt_hsmctrl")
+               # skip already stop[ed,ing] CDTs
+               echo $oldstate | grep stop && continue
+
+               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=shutdown"
+               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
+                       "stopped" 20 ||
+                       error "mds${mdtno} cdt state is not stopped"
+               do_facet mds${mdtno} "$LCTL set_param $mdt_hsmctrl=$oldstate"
+               wait_result mds${mdtno} "$LCTL get_param -n $mdt_hsmctrl" \
+                       "$oldstate" 20 ||
+                       error "mds${mdtno} cdt state is not $oldstate"
+       done
 }
 
 copytool_suspend() {
@@ -179,9 +222,9 @@ copytool_suspend() {
 
 copytool_remove_backend() {
        local fid=$1
-       local be=$(find $HSM_ARCHIVE -name $fid)
+       local be=$(do_facet $SINGLEAGT find $HSM_ARCHIVE -name $fid)
        echo "Remove from backend: $fid = $be"
-       rm -f $be
+       do_facet $SINGLEAGT rm -f $be
 }
 
 import_file() {
@@ -193,25 +236,77 @@ import_file() {
 
 make_archive() {
        local file=$HSM_ARCHIVE/$1
-       mkdir -p $(dirname $file)
-       dd if=/dev/urandom of=$file count=32 bs=1000000 ||
+       do_facet $SINGLEAGT mkdir -p $(dirname $file)
+       do_facet $SINGLEAGT dd if=/dev/urandom of=$file count=32 bs=1000000 ||
                error "cannot create $file"
 }
 
+copy2archive() {
+       local file=$HSM_ARCHIVE/$2
+       do_facet $SINGLEAGT mkdir -p $(dirname $file)
+       do_facet $SINGLEAGT cp -p $1 $file || error "cannot copy $1 to $file"
+}
+
+mdts_set_param() {
+       local arg=$1
+       local key=$2
+       local value=$3
+       local mdtno
+       local rc=0
+       if [[ "$value" != "" ]]; then
+               value="=$value"
+       fi
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               local facet=mds${mdtno}
+               # if $arg include -P option, run 1 set_param per MDT on the MGS
+               # else, run set_param on each MDT
+               [[ $arg = *"-P"* ]] && facet=mgs
+               do_facet $facet $LCTL set_param $arg mdt.${MDT[$idx]}.$key$value
+               [[ $? != 0 ]] && rc=1
+       done
+       return $rc
+}
+
+mdts_check_param() {
+       local key="$1"
+       local target="$2"
+       local timeout="$3"
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               wait_result mds${mdtno} \
+                       "$LCTL get_param -n $MDT_PREFIX${idx}.$key" "$target" \
+                       $timeout ||
+                       error "$key state is not '$target' on mds${mdtno}"
+       done
+}
+
 changelog_setup() {
-       CL_USER=$(do_facet $SINGLEMDS $LCTL --device $MDT0\
-                 changelog_register -n)
-       do_facet $SINGLEMDS lctl set_param mdd.$MDT0.changelog_mask="+hsm"
-       $LFS changelog_clear $MDT0 $CL_USER 0
+       CL_USERS=()
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               local cl_user=$(do_facet mds${mdtno} $LCTL \
+                            --device ${MDT[$idx]} \
+                            changelog_register -n)
+               CL_USERS+=($cl_user)
+               do_facet mds${mdtno} lctl set_param \
+                       mdd.${MDT[$idx]}.changelog_mask="+hsm"
+               $LFS changelog_clear ${MDT[$idx]} $cl_user 0
+       done
 }
 
 changelog_cleanup() {
-#      $LFS changelog $MDT0
-       [[ -n "$CL_USER" ]] || return 0
-
-       $LFS changelog_clear $MDT0 $CL_USER 0
-       do_facet $SINGLEMDS lctl --device $MDT0 changelog_deregister $CL_USER
-       CL_USER=
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               local idx=$(($mdtno - 1))
+               [[ -z  ${CL_USERS[$idx]} ]] && continue
+               $LFS changelog_clear ${MDT[$idx]} ${CL_USERS[$idx]} 0
+               do_facet mds${mdtno} lctl --device ${MDT[$idx]} \
+                       changelog_deregister ${CL_USERS[$idx]}
+       done
+       CL_USERS=()
 }
 
 changelog_get_flags() {
@@ -231,65 +326,58 @@ get_hsm_param() {
 set_hsm_param() {
        local param=$1
        local value=$2
-       do_facet $SINGLEMDS $LCTL set_param -n $HSM_PARAM.$param=$value
+       local opt=$3
+       mdts_set_param "$opt -n" "hsm.$param" "$value"
        return $?
 }
 
 set_test_state() {
        local cmd=$1
        local target=$2
-       do_facet $SINGLEMDS $LCTL set_param $MDT_PARAM.hsm_control=$cmd
-       wait_result $SINGLEMDS "$LCTL get_param -n $MDT_PARAM.hsm_control"\
-               $target 10 || error "cdt state is not $target"
+       mdts_set_param "" hsm_control "$cmd"
+       mdts_check_param hsm_control "$target" 10
 }
 
 cdt_set_sanity_policy() {
        if [[ "$CDT_POLICY_HAD_CHANGED" ]]
        then
                # clear all
-               do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=+NRA
-               do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=-NBR
+               mdts_set_param "" hsm.policy "+NRA"
+               mdts_set_param "" hsm.policy "-NBR"
                CDT_POLICY_HAD_CHANGED=
        fi
 }
 
 cdt_set_no_retry() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=+NRA
+       mdts_set_param "" hsm.policy "+NRA"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_clear_no_retry() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=-NRA
+       mdts_set_param "" hsm.policy "-NRA"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_set_non_blocking_restore() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=+NBR
+       mdts_set_param "" hsm.policy "+NBR"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_clear_non_blocking_restore() {
-       do_facet $SINGLEMDS $LCTL set_param $HSM_PARAM.policy=-NBR
+       mdts_set_param "" hsm.policy "-NBR"
        CDT_POLICY_HAD_CHANGED=true
 }
 
 cdt_clear_mount_state() {
-       # /!\ conf_param and set_param syntax differ +> we cannot use
-       # $MDT_PARAM
-       do_facet $SINGLEMDS $LCTL conf_param -d $FSNAME-MDT0000.mdt.hsm_control
+       mdts_set_param "-P -d" hsm_control ""
 }
 
 cdt_set_mount_state() {
-       # /!\ conf_param and set_param syntax differ +> we cannot use
-       # $MDT_PARAM
-       do_facet $SINGLEMDS $LCTL conf_param $FSNAME-MDT0000.mdt.hsm_control=$1
+       mdts_set_param "-P" hsm_control "$1"
 }
 
 cdt_check_state() {
-       local target=$1
-       wait_result $SINGLEMDS\
-               "$LCTL get_param -n $MDT_PARAM.hsm_control" "$target" 20 ||
-                       error "cdt state is not $target"
+       mdts_check_param hsm_control "$1" 20
 }
 
 cdt_disable() {
@@ -315,9 +403,9 @@ cdt_restart() {
 }
 
 needclients() {
-       local clnt_count=$1
-       if [[ $CLIENTCOUNT -lt $clnt_count ]]; then
-               skip "Need $clnt_count or more clients, have $CLIENTCOUNT"
+       local client_count=$1
+       if [[ $CLIENTCOUNT -lt $client_count ]]; then
+               skip "Need $client_count or more clients, have $CLIENTCOUNT"
                return 1
        fi
        return 0
@@ -331,8 +419,7 @@ get_hsm_flags() {
        local f=$1
        local u=$2
 
-       if [[ $u == "user" ]]
-       then
+       if [[ $u == "user" ]]; then
                local st=$($RUNAS $LFS hsm_state $f)
        else
                local st=$($LFS hsm_state $f)
@@ -374,15 +461,13 @@ check_hsm_flags_user() {
 copy_file() {
        local f=
 
-       if [[ -d $2 ]]
-       then
+       if [[ -d $2 ]]; then
                f=$2/$(basename $1)
        else
                f=$2
        fi
 
-       if [[ "$3" != 1 ]]
-       then
+       if [[ "$3" != 1 ]]; then
                f=${f/$DIR/$DIR2}
        fi
        rm -f $f
@@ -397,8 +482,15 @@ make_small() {
         path2fid $1 || error "cannot get fid on $1"
 }
 
+make_small_sync() {
+       dd if=/dev/urandom of=$1 count=1 bs=1M conv=sync ||
+               error "cannot create $1"
+       path2fid $1 || error "cannot get fid on $1"
+}
+
 cleanup_large_files() {
-       local ratio=$(df $MOUNT |awk '{print $5}' |sed 's/%//g' |grep -v Use)
+       local ratio=$(df -P $MOUNT | tail -1 | awk '{print $5}' |
+                     sed 's/%//g')
        [ $ratio -gt 50 ] && find $MOUNT -size +10M -exec rm -f {} \;
 }
 
@@ -462,19 +554,37 @@ wait_request_state() {
        local fid=$1
        local request=$2
        local state=$3
+       # 4th arg (mdt index) is optional
+       local mdtidx=${4:-0}
+       local mds=mds$(($mdtidx + 1))
 
-       local cmd="$LCTL get_param -n $HSM_PARAM.agent_actions"
+       local cmd="$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.actions"
        cmd+=" | awk '/'$fid'.*action='$request'/ {print \\\$13}' | cut -f2 -d="
 
-       wait_result $SINGLEMDS "$cmd" $state 100 ||
-               error "request on $fid is not $state"
+       wait_result $mds "$cmd" $state 100 ||
+               error "request on $fid is not $state on $mds"
+}
+
+wait_request_progress() {
+       local fid=$1
+       local request=$2
+       local progress=$3
+       # 4th arg (mdt index) is optional
+       local mdtidx=${4:-0}
+       local mds=mds$((mdtidx + 1))
+
+       local cmd="$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.active_requests"
+       cmd+=" | awk '/'$fid'.*action='$request'/ {print \\\$12}' | cut -f2 -d="
+
+       wait_result $mds "$cmd" $progress 100 ||
+               error "request on $fid has not made progress $progress on $mds"
 }
 
 get_request_state() {
        local fid=$1
        local request=$2
 
-       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.agent_actions |"\
+       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.actions |"\
                "awk '/'$fid'.*action='$request'/ {print \\\$13}' | cut -f2 -d="
 }
 
@@ -482,14 +592,14 @@ get_request_count() {
        local fid=$1
        local request=$2
 
-       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.agent_actions |"\
+       do_facet $SINGLEMDS "$LCTL get_param -n $HSM_PARAM.actions |"\
                "awk -vn=0 '/'$fid'.*action='$request'/ {n++}; END {print n}'"
 }
 
 wait_all_done() {
        local timeout=$1
 
-       local cmd="$LCTL get_param -n $HSM_PARAM.agent_actions"
+       local cmd="$LCTL get_param -n $HSM_PARAM.actions"
        cmd+=" | egrep 'WAITING|STARTED'"
 
        wait_result $SINGLEMDS "$cmd" "" $timeout ||
@@ -501,8 +611,8 @@ wait_for_grace_delay() {
        sleep $val
 }
 
-MDT0=$($LCTL get_param -n mdc.*.mds_server_uuid |
-       awk '{gsub(/_UUID/,""); print $1}' | head -1)
+# populate MDT device array
+get_mdt_devices
 
 # initiate variables
 init_agt_vars
@@ -730,10 +840,10 @@ test_10a() {
                error "hsm_archive failed"
        wait_request_state $fid ARCHIVE SUCCEED
 
-       local AFILE=$(ls $HSM_ARCHIVE/*/*/*/*/*/*/$fid) ||
+       local AFILE=$(do_facet $SINGLEAGT ls $HSM_ARCHIVE'/*/*/*/*/*/*/'$fid) ||
                error "fid $fid not in archive $HSM_ARCHIVE"
        echo "Verifying content"
-       diff $f $AFILE || error "archived file differs"
+       do_facet $SINGLEAGT diff $f $AFILE || error "archived file differs"
        echo "Verifying hsm state "
        check_hsm_flags $f "0x00000009"
 
@@ -751,7 +861,7 @@ test_10b() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
+       mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid=$(copy_file /etc/hosts $f)
        $LFS hsm_archive $f || error "archive request failed"
@@ -770,7 +880,7 @@ test_10c() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
+       mkdir -p $DIR/$tdir
        local f=$DIR/$tdir/$tfile
        local fid=$(copy_file /etc/hosts $f)
        $LFS hsm_set --noarchive $f
@@ -791,7 +901,7 @@ test_10d() {
        wait_request_state $fid ARCHIVE SUCCEED
 
        local ar=$(get_hsm_archive_id $f)
-       local dflt=$(get_hsm_param archive_id)
+       local dflt=$(get_hsm_param default_archive_id)
        [[ $ar == $dflt ]] ||
                error "archived file is not on default archive: $ar != $dflt"
 
@@ -800,8 +910,8 @@ test_10d() {
 run_test 10d "Archive a file on the default archive id"
 
 test_11() {
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp /etc/hosts $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/hosts $tdir/$tfile
        local f=$DIR/$tdir/$tfile
 
        import_file $tdir/$tfile $f
@@ -809,7 +919,7 @@ test_11() {
        check_hsm_flags $f "0x0000000d"
 
        local LSZ=$(stat -c "%s" $f)
-       local ASZ=$(stat -c "%s" $HSM_ARCHIVE/$tdir/$tfile)
+       local ASZ=$(do_facet $SINGLEAGT stat -c "%s" $HSM_ARCHIVE/$tdir/$tfile)
 
        echo "Verifying imported size $LSZ=$ASZ"
        [[ $LSZ -eq $ASZ ]] || error "Incorrect size $LSZ != $ASZ"
@@ -820,7 +930,7 @@ test_11() {
        local fid=$(path2fid $f)
        echo "Verifying new fid $fid in archive"
 
-       local AFILE=$(ls $HSM_ARCHIVE/*/*/*/*/*/*/$fid) ||
+       local AFILE=$(do_facet $SINGLEAGT ls $HSM_ARCHIVE'/*/*/*/*/*/*/'$fid) ||
                error "fid $fid not in archive $HSM_ARCHIVE"
 }
 run_test 11 "Import a file"
@@ -829,8 +939,9 @@ test_12a() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp /etc/hosts $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/hosts $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
        local f=$DIR2/$tdir/$tfile
@@ -844,7 +955,7 @@ test_12a() {
        echo "Verifying file state: "
        check_hsm_flags $f "0x00000009"
 
-       diff -q $HSM_ARCHIVE/$tdir/$tfile $f
+       do_facet $SINGLEAGT diff -q $HSM_ARCHIVE/$tdir/$tfile $f
 
        [[ $? -eq 0 ]] || error "Restored file differs"
 
@@ -856,8 +967,9 @@ test_12b() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp /etc/hosts $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/hosts $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
        echo "Verifying released state: "
@@ -868,7 +980,7 @@ test_12b() {
        echo "Verifying file state after restore: "
        check_hsm_flags $f "0x00000009"
 
-       diff -q $HSM_ARCHIVE/$tdir/$tfile $f
+       do_facet $SINGLEAGT diff -q $HSM_ARCHIVE/$tdir/$tfile $f
 
        [[ $? -eq 0 ]] || error "Restored file differs"
 
@@ -904,7 +1016,8 @@ test_12d() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
+       mkdir -p $DIR/$tdir
+
        local f=$DIR/$tdir/$tfile
        local fid=$(copy_file /etc/hosts $f)
        $LFS hsm_restore $f || error "restore of non archived file failed"
@@ -1045,12 +1158,14 @@ test_12n() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp /etc/hosts $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/hosts $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
 
-       cmp /etc/hosts $f || error "Restored file differs"
+       do_facet $SINGLEAGT cmp /etc/hosts $f ||
+               error "Restored file differs"
 
        $LFS hsm_release $f || error "release of $f failed"
 
@@ -1058,6 +1173,53 @@ test_12n() {
 }
 run_test 12n "Import/implicit restore/release"
 
+test_12o() {
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(copy_file /etc/hosts $f)
+
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f || error "release of $f failed"
+
+#define OBD_FAIL_MDS_HSM_SWAP_LAYOUTS          0x152
+       do_facet $SINGLEMDS lctl set_param fail_loc=0x152
+
+       # set no retry action mode
+       cdt_set_no_retry
+
+       diff -q /etc/hosts $f
+       local st=$?
+
+       # we check we had a restore failure
+       wait_request_state $fid RESTORE FAILED
+
+       [[ $st -eq 0 ]] && error "Restore must fail"
+
+       # remove no retry action mode
+       cdt_clear_no_retry
+
+       # check file is still released
+       check_hsm_flags $f "0x0000000d"
+
+       # retry w/o failure injection
+       do_facet $SINGLEMDS lctl set_param fail_loc=0
+
+       diff -q /etc/hosts $f
+       st=$?
+
+       # we check we had a restore done
+       wait_request_state $fid RESTORE SUCCEED
+
+       [[ $st -eq 0 ]] || error "Restored file differs"
+
+       copytool_cleanup
+}
+run_test 12o "Layout-swap failure during Restore leaves file released"
+
 test_13() {
        # test needs a running copytool
        copytool_setup
@@ -1069,24 +1231,23 @@ test_13() {
        # populate directory to be imported
        for d in $(seq 1 10); do
                local CURR_DIR="$HSM_ARCHIVE/$ARC_SUBDIR/dir.$d"
-               mkdir -p "$CURR_DIR"
+               do_facet $SINGLEAGT mkdir -p "$CURR_DIR"
                for f in $(seq 1 10); do
                        CURR_FILE="$CURR_DIR/$tfile.$f"
                        # write file-specific data
-                       echo "d=$d, f=$f, dir=$CURR_DIR, file=$CURR_FILE"\
-                               > $CURR_FILE
+                       do_facet $SINGLEAGT \
+                               "echo d=$d, f=$f, dir=$CURR_DIR, "\
+                                       "file=$CURR_FILE > $CURR_FILE"
                done
        done
        # import to Lustre
        import_file "$ARC_SUBDIR" $DIR/$tdir
        # diff lustre content and origin (triggers file restoration)
        # there must be 10x10 identical files, and no difference
-       local cnt_ok=$(diff -rs $HSM_ARCHIVE/$ARC_SUBDIR \
-                      $DIR/$tdir/$ARC_SUBDIR |
-               grep identical | wc -l)
-       local cnt_diff=$(diff -r $HSM_ARCHIVE/$ARC_SUBDIR \
-                        $DIR/$tdir/$ARC_SUBDIR |
-               wc -l)
+       local cnt_ok=$(do_facet $SINGLEAGT diff -rs $HSM_ARCHIVE/$ARC_SUBDIR \
+                      $DIR/$tdir/$ARC_SUBDIR | grep identical | wc -l)
+       local cnt_diff=$(do_facet $SINGLEAGT diff -r $HSM_ARCHIVE/$ARC_SUBDIR \
+                        $DIR/$tdir/$ARC_SUBDIR | wc -l)
 
        [ $cnt_diff -eq 0 ] ||
                error "$cnt_diff imported files differ from read data"
@@ -1253,19 +1414,41 @@ test_21() {
        local fid=$(make_small $f)
        check_hsm_flags $f "0x00000000"
 
+       # LU-4388/LU-4389 - ZFS does not report full number of blocks
+       # used until file is flushed to disk
+       if [  $(facet_fstype ost1) == "zfs" ]; then
+           # this causes an OST_SYNC rpc to be sent
+           dd if=/dev/zero of=$f bs=512 count=1 oflag=sync conv=notrunc,fsync
+           # clear locks to reread file data
+           cancel_lru_locks osc
+       fi
+
+       local orig_size=$(stat -c "%s" $f)
+       local orig_blocks=$(stat -c "%b" $f)
+
+       start_full_debug_logging
+
        $LFS hsm_archive $f || error "could not archive file"
        wait_request_state $fid ARCHIVE SUCCEED
 
-       [ $(stat -c "%b" $f) -ne "0" ] || error "wrong block number"
-       local sz=$(stat -c "%s" $f)
-       [ $sz -ne "0" ] || error "file size should not be zero"
+       local blocks=$(stat -c "%b" $f)
+       [ $blocks -eq $orig_blocks ] ||
+               error "$f: wrong block number after archive: " \
+                     "$blocks != $orig_blocks"
+       local size=$(stat -c "%s" $f)
+       [ $size -eq $orig_size ] ||
+               error "$f: wrong size after archive: $size != $orig_size"
 
        # Release and check states
        $LFS hsm_release $f || error "could not release file"
        check_hsm_flags $f "0x0000000d"
 
-       [ $(stat -c "%b" $f) -eq "0" ] || error "wrong block number"
-       [ $(stat -c "%s" $f) -eq $sz ] || error "wrong file size"
+       blocks=$(stat -c "%b" $f)
+       [ $blocks -gt 5 ] &&
+               error "$f: too many blocks after release: $blocks > 5"
+       size=$(stat -c "%s" $f)
+       [ $size -ne $orig_size ] &&
+               error "$f: wrong size after release: $size != $orig_size"
 
        # Check we can release an file without stripe info
        f=$f.nolov
@@ -1283,6 +1466,8 @@ test_21() {
        $LFS hsm_release $f || fail "second release should succeed"
        check_hsm_flags $f "0x0000000d"
 
+       stop_full_debug_logging
+
        copytool_cleanup
 }
 run_test 21 "Simple release tests"
@@ -1478,8 +1663,8 @@ test_24b() {
        $LFS hsm_archive $file
        wait_request_state $fid ARCHIVE SUCCEED
 
-       $LFS hsm_release $file ||
-               check_hsm_flags $file "0x0000000d"
+       $LFS hsm_release $file
+       check_hsm_flags $file "0x0000000d"
 
        $LFS hsm_restore $file
        wait_request_state $fid RESTORE SUCCEED
@@ -1488,8 +1673,8 @@ test_24b() {
        $RUNAS $LFS hsm_state $file ||
                error "user '$RUNAS_ID' cannot get HSM state of '$file'"
 
-       $LFS hsm_release $file ||
-               check_hsm_flags $file "0x0000000d"
+       $LFS hsm_release $file
+       check_hsm_flags $file "0x0000000d"
 
        # Check that ordinary user can accessed released file.
        sum1=$($RUNAS md5sum $file) ||
@@ -1502,12 +1687,141 @@ test_24b() {
 }
 run_test 24b "root can archive, release, and restore user files"
 
+cleanup_test_24c() {
+       trap 0
+       set_hsm_param user_request_mask RESTORE
+       set_hsm_param group_request_mask RESTORE
+       set_hsm_param other_request_mask RESTORE
+}
+
+test_24c() {
+       local file=$DIR/$tdir/$tfile
+       local action=archive
+       local user_save
+       local group_save
+       local other_save
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       # Save the default masks and check that cleanup_24c will
+       # restore the request masks correctly.
+       user_save=$(get_hsm_param user_request_mask)
+       group_save=$(get_hsm_param group_request_mask)
+       other_save=$(get_hsm_param other_request_mask)
+
+       [ "$user_save" == RESTORE ] ||
+               error "user_request_mask is '$user_save' expected 'RESTORE'"
+       [ "$group_save" == RESTORE ] ||
+               error "group_request_mask is '$group_save' expected 'RESTORE'"
+       [ "$other_save" == RESTORE ] ||
+               error "other_request_mask is '$other_save' expected 'RESTORE'"
+
+       trap cleanup_test_24c EXIT
+
+       # User.
+       rm -f $file
+       make_small $file
+       chown $RUNAS_ID:nobody $file ||
+               error "cannot chown '$file' to '$RUNAS_ID:nobody'"
+
+       set_hsm_param user_request_mask ""
+       $RUNAS $LFS hsm_$action $file &&
+               error "$action by user should fail"
+
+       set_hsm_param user_request_mask $action
+       $RUNAS $LFS hsm_$action $file ||
+               error "$action by user should succeed"
+
+       # Group.
+       rm -f $file
+       make_small $file
+       chown nobody:$RUNAS_GID $file ||
+               error "cannot chown '$file' to 'nobody:$RUNAS_GID'"
+
+       set_hsm_param group_request_mask ""
+       $RUNAS $LFS hsm_$action $file &&
+               error "$action by group should fail"
+
+       set_hsm_param group_request_mask $action
+       $RUNAS $LFS hsm_$action $file ||
+               error "$action by group should succeed"
+
+       # Other.
+       rm -f $file
+       make_small $file
+       chown nobody:nobody $file ||
+               error "cannot chown '$file' to 'nobody:nobody'"
+
+       set_hsm_param other_request_mask ""
+       $RUNAS $LFS hsm_$action $file &&
+               error "$action by other should fail"
+
+       set_hsm_param other_request_mask $action
+       $RUNAS $LFS hsm_$action $file ||
+               error "$action by other should succeed"
+
+       copytool_cleanup
+       cleanup_test_24c
+}
+run_test 24c "check that user,group,other request masks work"
+
+cleanup_test_24d() {
+       trap 0
+       mount -o remount,rw $MOUNT2
+}
+
+test_24d() {
+       local file1=$DIR/$tdir/$tfile
+       local file2=$DIR2/$tdir/$tfile
+       local fid1
+       local fid2
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       rm -f $file1
+       fid1=$(make_small $file1)
+
+       trap cleanup_test_24d EXIT
+
+       mount -o remount,ro $MOUNT2
+
+       fid2=$(path2fid $file2)
+       [ "$fid1" == "$fid2" ] ||
+               error "FID mismatch '$fid1' != '$fid2'"
+
+       $LFS hsm_archive $file2 &&
+               error "archive should fail on read-only mount"
+       check_hsm_flags $file1 "0x00000000"
+
+       $LFS hsm_archive $file1
+       wait_request_state $fid1 ARCHIVE SUCCEED
+
+       $LFS hsm_release $file1
+       $LFS hsm_restore $file2
+       wait_request_state $fid1 RESTORE SUCCEED
+
+       $LFS hsm_release $file1 || error "cannot release '$file1'"
+       dd if=$file2 of=/dev/null bs=1M || "cannot read '$file2'"
+
+       $LFS hsm_release $file2 &&
+               error "release should fail on read-only mount"
+
+       copytool_cleanup
+       cleanup_test_24d
+}
+run_test 24d "check that read-only mounts are respected"
+
 test_25a() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp /etc/hosts $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/hosts $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
 
        import_file $tdir/$tfile $f
@@ -1635,8 +1949,9 @@ test_30a() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp -p /bin/true $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+       copy2archive /bin/true $tdir/$tfile
+
        local f=$DIR/$tdir/true
        import_file $tdir/$tfile $f
 
@@ -1690,6 +2005,41 @@ test_30b() {
 }
 run_test 30b "Restore at exec (release case)"
 
+test_30c() {
+       needclients 2 || return 0
+
+       # test needs a running copytool
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/SLEEP
+       local fid=$(copy_file /bin/sleep $f)
+       chmod 755 $f
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
+       wait_request_state $fid ARCHIVE SUCCEED
+       $LFS hsm_release $f
+       check_hsm_flags $f "0x0000000d"
+       # set no retry action mode
+       cdt_set_no_retry
+       do_node $CLIENT2 "$f 10" &
+       local pid=$!
+       sleep 3
+       echo 'Hi!' > $f
+       [[ $? == 0 ]] && error "Update during exec of released file must fail"
+       wait $pid
+       [[ $? == 0 ]] || error "Execution failed during run"
+       cmp /bin/sleep $f
+       [[ $? == 0 ]] || error "Binary overwritten during exec"
+
+       # cleanup
+       # remove no try action mode
+       cdt_clear_no_retry
+       check_hsm_flags $f "0x00000009"
+
+       copytool_cleanup
+}
+run_test 30c "Update during exec of released file must fail"
+
 restore_and_check_size() {
        local f=$1
        local fid=$2
@@ -1704,8 +2054,7 @@ restore_and_check_size() {
                n=$(stat -c "%s" $f)
                # we echo in both cases to show stat is not
                # hang
-               if [[ $n != $s ]]
-               then
+               if [[ $n != $s ]]; then
                        echo "size seen is $n != $s"
                        err=1
                else
@@ -1715,13 +2064,12 @@ restore_and_check_size() {
                sleep 10
                cpt=$((cpt + 1))
        done
-       if [[ $cpt -lt 10 ]]
-       then
-               echo " restore is too long"
-       else
+       if [[ $cpt -lt 10 ]]; then
                echo " "done
+       else
+               echo " restore is too long"
+               wait_request_state $fid RESTORE SUCCEED
        fi
-       wait_request_state $fid RESTORE SUCCEED
        return $err
 }
 
@@ -1951,7 +2299,13 @@ test_40() {
                        fid=$(copy_file /etc/hosts $f.$p.$i)
                done
        done
-       copytool_setup
+       # force copytool to use a local/temp archive dir to ensure best
+       # performance vs remote/NFS mounts used in auto-tests
+       if df --local $HSM_ARCHIVE >/dev/null 2>&1 ; then
+               copytool_setup
+       else
+               copytool_setup $SINGLEAGT $MOUNT $HSM_ARCHIVE_NUMBER $TMP/$tdir
+       fi
        # to be sure wait_all_done will not be mislead by previous tests
        cdt_purge
        wait_for_grace_delay
@@ -2195,6 +2549,36 @@ test_58() {
 }
 run_test 58 "Truncate a released file will trigger restore"
 
+test_60() {
+       local interval=5
+       local progress_timeout=$((interval * 2))
+
+       # test needs a new running copytool
+       copytool_cleanup
+       HSMTOOL_UPDATE_INTERVAL=$interval copytool_setup
+
+       mkdir -p $DIR/$tdir
+       local f=$DIR/$tdir/$tfile
+       local fid=$(make_large_for_progress $f)
+
+       local start_at=$(date +%s)
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f ||
+               error "could not archive file"
+       wait_request_progress $fid ARCHIVE 5242880
+       local finish_at=$(date +%s)
+       local elapsed=$((finish_at - start_at))
+
+       if [ $elapsed -gt $progress_timeout ]; then
+               error "Expected progress update within $progress_timeout seconds"
+       elif [ $elapsed -lt $interval ]; then
+               error "Expected progress update after at least $interval seconds"
+       fi
+
+       cdt_clear_no_retry
+       copytool_cleanup
+}
+run_test 60 "Changing progress update interval from default"
+
 test_90() {
        file_count=57
        mkdir -p $DIR/$tdir
@@ -2239,8 +2623,7 @@ double_verify_reset_hsm_param() {
        # restore value
        set_hsm_param $p $save
 
-       if [[ $rc == 0 ]]
-       then
+       if [[ $rc == 0 ]]; then
                error "we must not be able to set $HSM_PARAM.$p to 0"
        fi
 }
@@ -2248,9 +2631,9 @@ double_verify_reset_hsm_param() {
 test_100() {
        double_verify_reset_hsm_param loop_period
        double_verify_reset_hsm_param grace_delay
-       double_verify_reset_hsm_param request_timeout
+       double_verify_reset_hsm_param active_request_timeout
        double_verify_reset_hsm_param max_requests
-       double_verify_reset_hsm_param archive_id
+       double_verify_reset_hsm_param default_archive_id
 }
 run_test 100 "Set coordinator /proc tunables"
 
@@ -2278,7 +2661,7 @@ test_103() {
 
        echo "Current requests"
        local res=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep -v CANCELED | grep -v SUCCEED | grep -v FAILED")
 
        [[ -z "$res" ]] || error "Some request have not been canceled"
@@ -2300,7 +2683,7 @@ test_104() {
        cdt_disable
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER --data $DATA $f
        local data1=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep $fid | cut -f16 -d=")
        cdt_enable
 
@@ -2321,12 +2704,12 @@ test_105() {
                $LFS hsm_archive $DIR/$tdir/$i
        done
        local reqcnt1=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
        cdt_restart
        cdt_disable
        local reqcnt2=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
        cdt_enable
        cdt_purge
@@ -2336,28 +2719,70 @@ test_105() {
 }
 run_test 105 "Restart of coordinator"
 
+get_agent_by_uuid_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       do_facet $mds "$LCTL get_param -n ${MDT_PREFIX}${mdtidx}.hsm.agents |\
+                grep $uuid"
+}
+
+check_agent_registered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ ! -z "$agent" ]]; then
+               echo "found agent $agent on $mds"
+       else
+               error "uuid $uuid not found in agent list on $mds"
+       fi
+}
+
+check_agent_unregistered_by_mdt() {
+       local uuid=$1
+       local mdtidx=$2
+       local mds=mds$(($mdtidx + 1))
+       local agent=$(get_agent_by_uuid_mdt $uuid $mdtidx)
+       if [[ -z "$agent" ]]; then
+               echo "uuid not found in agent list on $mds"
+       else
+               error "uuid found in agent list on $mds: $agent"
+       fi
+}
+
+check_agent_registered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_registered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
+check_agent_unregistered() {
+       local uuid=$1
+       local mdsno
+       for mdsno in $(seq 1 $MDSCOUNT); do
+               check_agent_unregistered_by_mdt $uuid $((mdsno - 1))
+       done
+}
+
 test_106() {
-       # test needs a running copytool
+       local uuid=$(do_rpc_nodes $(facet_active_host $SINGLEAGT) \
+               get_client_uuid $MOUNT | cut -d' ' -f2)
+
        copytool_setup
+       check_agent_registered $uuid
+
+       search_copytools || error "No copytool found"
 
-       local uuid=$(do_rpc_nodes $(facet_active_host $SINGLEAGT) \
-               get_client_uuid | cut -d' ' -f2)
-       local agent=$(do_facet $SINGLEMDS $LCTL get_param -n $HSM_PARAM.agents |
-               grep $uuid)
        copytool_cleanup
-       [[ ! -z "$agent" ]] || error "My uuid $uuid not found in agent list"
-       local agent=$(do_facet $SINGLEMDS $LCTL get_param -n $HSM_PARAM.agents |
-               grep $uuid)
-       [[ -z "$agent" ]] ||
-               error "My uuid $uuid still found in agent list,"\
-                     " after copytool shutdown"
+       check_agent_unregistered $uuid
+
        copytool_setup
-       local agent=$(do_facet $SINGLEMDS $LCTL get_param -n $HSM_PARAM.agents |
-               grep $uuid)
+       check_agent_registered $uuid
+
        copytool_cleanup
-       [[ ! -z "$agent" ]] ||
-               error "My uuid $uuid not found in agent list after"\
-                     " copytool restart"
 }
 run_test 106 "Copytool register/unregister"
 
@@ -2421,8 +2846,10 @@ test_110a() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
-       cp /etc/passwd $HSM_ARCHIVE/$tdir/$tfile
+       mkdir -p $DIR/$tdir
+
+       copy2archive /etc/passwd $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
        import_file $tdir/$tfile $f
        local fid=$(path2fid $f)
@@ -2476,9 +2903,11 @@ test_111a() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/passwd $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
-       cp /etc/passwd $HSM_ARCHIVE/$tdir/$tfile
+
        import_file $tdir/$tfile $f
        local fid=$(path2fid $f)
 
@@ -2629,7 +3058,7 @@ test_220() {
        $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $f
        wait_request_state $fid ARCHIVE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
        changelog_cleanup
 
        local target=0x0
@@ -2656,7 +3085,7 @@ test_221() {
        wait_request_state $fid ARCHIVE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0x7d
        [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
@@ -2669,9 +3098,10 @@ test_222a() {
        # test needs a running copytool
        copytool_setup
 
-       mkdir -p $DIR/$tdir $HSM_ARCHIVE/$tdir
+       mkdir -p $DIR/$tdir
+       copy2archive /etc/passwd $tdir/$tfile
+
        local f=$DIR/$tdir/$tfile
-       cp /etc/passwd $HSM_ARCHIVE/$tdir/$tfile
        import_file $tdir/$tfile $f
        local fid=$(path2fid $f)
 
@@ -2680,7 +3110,7 @@ test_222a() {
        $LFS hsm_restore $f
        wait_request_state $fid RESTORE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0x80
        [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
@@ -2706,7 +3136,7 @@ test_222b() {
 
        wait_request_state $fid RESTORE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0x80
        [[ $flags == $target ]] || error "Changelog flag is $flags not $target"
@@ -2735,7 +3165,7 @@ test_223a() {
        wait_request_state $fid RESTORE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0xfd
        [[ $flags == $target ]] ||
@@ -2764,7 +3194,7 @@ test_223b() {
        wait_request_state $fid RESTORE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -1)
 
        local target=0xfd
        [[ $flags == $target ]] ||
@@ -2790,7 +3220,7 @@ test_224() {
        $LFS hsm_remove $f
        wait_request_state $fid REMOVE SUCCEED
 
-       local flags=$(changelog_get_flags $MDT0 HSM $fid | tail -1)
+       local flags=$(changelog_get_flags ${MDT[0]} HSM $fid | tail -n 1)
 
        local target=0x200
        [[ $flags == $target ]] ||
@@ -2826,9 +3256,9 @@ test_225() {
        wait_request_state $fid REMOVE CANCELED
        wait_request_state $fid CANCEL SUCCEED
 
-       flags=$(changelog_get_flags $MDT0 RENME $fid2)
-       local flags=$($LFS changelog $MDT0 | grep HSM | grep $fid | tail -1 |
-               awk '{print $5}')
+       flags=$(changelog_get_flags ${MDT[0]} RENME $fid2)
+       local flags=$($LFS changelog ${MDT[0]} | grep HSM | grep $fid |
+               tail -n 1 | awk '{print $5}')
 
        local target=0x27d
        [[ $flags == $target ]] ||
@@ -2860,7 +3290,7 @@ test_226() {
 
        rm $f1 || error "rm $f1 failed"
 
-       local flags=$(changelog_get_flags $MDT0 UNLNK $fid1)
+       local flags=$(changelog_get_flags ${MDT[0]} UNLNK $fid1)
 
        local target=0x3
        [[ $flags == $target ]] ||
@@ -2868,7 +3298,7 @@ test_226() {
 
        mv $f3 $f2 || error "mv $f3 $f2 failed"
 
-       flags=$(changelog_get_flags $MDT0 RENME $fid2)
+       flags=$(changelog_get_flags ${MDT[0]} RENME $fid2)
 
        target=0x3
        [[ $flags == $target ]] ||
@@ -2888,7 +3318,7 @@ check_flags_changes() {
        local target=0x280
        $LFS hsm_set --$hsm_flag $f ||
                error "Cannot set $hsm_flag on $f"
-       local flags=($(changelog_get_flags $MDT0 HSM $fid))
+       local flags=($(changelog_get_flags ${MDT[0]} HSM $fid))
        local seen=${#flags[*]}
        cnt=$((fst + cnt))
        [[ $seen == $cnt ]] ||
@@ -2899,7 +3329,7 @@ check_flags_changes() {
 
        $LFS hsm_clear --$hsm_flag $f ||
                error "Cannot clear $hsm_flag on $f"
-       flags=($(changelog_get_flags $MDT0 HSM $fid))
+       flags=($(changelog_get_flags ${MDT[0]} HSM $fid))
        seen=${#flags[*]}
        cnt=$(($cnt + 1))
        [[ $cnt == $seen ]] ||
@@ -2935,6 +3365,42 @@ test_227() {
 }
 run_test 227 "changelog when explicit setting of HSM flags"
 
+test_228() {
+       # test needs a running copytool
+       copytool_setup
+
+       local fid=$(make_small_sync $DIR/$tfile)
+       $LFS hsm_archive --archive $HSM_ARCHIVE_NUMBER $DIR/$tfile
+       wait_request_state $fid ARCHIVE SUCCEED
+
+       $LFS hsm_release $DIR/$tfile
+       check_hsm_flags $DIR/$tfile "0x0000000d"
+
+       filefrag $DIR/$tfile | grep " 1 extent found" ||
+               error "filefrag on released file must return only one extent"
+
+       # only newer versions of cp detect sparse files by stat/FIEMAP
+       # (LU-2580)
+       cp --sparse=auto $DIR/$tfile $DIR/$tfile.2 ||
+               error "copying $DIR/$tfile"
+       cmp $DIR/$tfile $DIR/$tfile.2 || error "comparing copied $DIR/$tfile"
+
+       $LFS hsm_release $DIR/$tfile
+       check_hsm_flags $DIR/$tfile "0x0000000d"
+
+       mkdir -p $DIR/$tdir || error "mkdir $tdir failed"
+
+       tar cf - --sparse $DIR/$tfile | tar xvf - -C $DIR/$tdir ||
+               error "tar failed"
+       cmp $DIR/$tfile $DIR/$tdir/$DIR/$tfile ||
+               error "comparing untarred $DIR/$tfile"
+
+       rm -f $DIR/$tfile $DIR/$tfile.2 ||
+               error "rm $DIR/$tfile or $DIR/$tfile.2 failed"
+       copytool_cleanup
+}
+run_test 228 "On released file, return extend to FIEMAP. For [cp,tar] --sparse"
+
 test_250() {
        # test needs a running copytool
        copytool_setup
@@ -2959,12 +3425,12 @@ test_250() {
        while [[ $cnt != 0 || $wt != 0 ]]; do
                sleep 1
                cnt=$(do_facet $SINGLEMDS "$LCTL get_param -n\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep STARTED | grep -v CANCEL | wc -l")
                [[ $cnt -le $maxrequest ]] ||
                        error "$cnt > $maxrequest too many started requests"
                wt=$(do_facet $SINGLEMDS "$LCTL get_param\
-                       $HSM_PARAM.agent_actions |\
+                       $HSM_PARAM.actions |\
                        grep WAITING | wc -l")
                echo "max=$maxrequest started=$cnt waiting=$wt"
        done
@@ -2983,8 +3449,8 @@ test_251() {
 
        cdt_disable
        # to have a short test
-       local old_to=$(get_hsm_param request_timeout)
-       set_hsm_param request_timeout 4
+       local old_to=$(get_hsm_param active_request_timeout)
+       set_hsm_param active_request_timeout 4
        # to be sure the cdt will wake up frequently so
        # it will be able to cancel the "old" request
        local old_loop=$(get_hsm_param loop_period)
@@ -2996,7 +3462,7 @@ test_251() {
        sleep 5
        wait_request_state $fid ARCHIVE CANCELED
 
-       set_hsm_param request_timeout $old_to
+       set_hsm_param active_request_timeout $old_to
        set_hsm_param loop_period $old_loop
 
        copytool_cleanup
@@ -3030,6 +3496,209 @@ test_300() {
 }
 run_test 300 "On disk coordinator state kept between MDT umount/mount"
 
+test_301() {
+       local ai=$(get_hsm_param default_archive_id)
+       local new=$((ai + 1))
+
+       set_hsm_param default_archive_id $new -P
+       fail $SINGLEMDS
+       local res=$(get_hsm_param default_archive_id)
+
+       # clear value
+       set_hsm_param default_archive_id "" "-P -d"
+
+       [[ $new == $res ]] || error "Value after MDS restart is $res != $new"
+}
+run_test 301 "HSM tunnable are persistent"
+
+test_302() {
+       local ai=$(get_hsm_param default_archive_id)
+       local new=$((ai + 1))
+
+       # stop coordinator
+       cdt_shutdown
+
+       set_hsm_param default_archive_id $new -P
+
+       local mdtno
+       for mdtno in $(seq 1 $MDSCOUNT); do
+               fail mds${mdtno}
+       done
+
+       # check cdt is on
+       cdt_check_state enabled
+
+       local res=$(get_hsm_param default_archive_id)
+
+       # clear value
+       set_hsm_param default_archive_id "" "-P -d"
+
+       [[ $new == $res ]] || error "Value after MDS restart is $res != $new"
+}
+run_test 302 "HSM tunnable are persistent when CDT is off"
+
+test_400() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local dir_mdt0=$DIR/$tdir/mdt0
+       local dir_mdt1=$DIR/$tdir/mdt1
+
+       # create 1 dir per MDT
+       $LFS mkdir -i 0 $dir_mdt0 || error "lfs mkdir"
+       $LFS mkdir -i 1 $dir_mdt1 || error "lfs mkdir"
+
+       # create 1 file in each MDT
+       local fid1=$(make_small $dir_mdt0/$tfile)
+       local fid2=$(make_small $dir_mdt1/$tfile)
+
+       # check that hsm request on mdt0 is sent to the right MDS
+       $LFS hsm_archive $dir_mdt0/$tfile || error "lfs hsm_archive"
+       wait_request_state $fid1 ARCHIVE SUCCEED 0 &&
+               echo "archive successful on mdt0"
+
+       # check that hsm request on mdt1 is sent to the right MDS
+       $LFS hsm_archive $dir_mdt1/$tfile || error "lfs hsm_archive"
+       wait_request_state $fid2 ARCHIVE SUCCEED 1 &&
+               echo "archive successful on mdt1"
+
+       copytool_cleanup
+       # clean test files and directories
+       rm -rf $dir_mdt0 $dir_mdt1
+}
+run_test 400 "Single request is sent to the right MDT"
+
+test_401() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       mkdir -p $DIR/$tdir
+
+       local dir_mdt0=$DIR/$tdir/mdt0
+       local dir_mdt1=$DIR/$tdir/mdt1
+
+       # create 1 dir per MDT
+       $LFS mkdir -i 0 $dir_mdt0 || error "lfs mkdir"
+       $LFS mkdir -i 1 $dir_mdt1 || error "lfs mkdir"
+
+       # create 1 file in each MDT
+       local fid1=$(make_small $dir_mdt0/$tfile)
+       local fid2=$(make_small $dir_mdt1/$tfile)
+
+       # check that compound requests are shunt to the rights MDTs
+       $LFS hsm_archive $dir_mdt0/$tfile $dir_mdt1/$tfile ||
+               error "lfs hsm_archive"
+       wait_request_state $fid1 ARCHIVE SUCCEED 0 &&
+               echo "archive successful on mdt0"
+       wait_request_state $fid2 ARCHIVE SUCCEED 1 &&
+               echo "archive successful on mdt1"
+
+       copytool_cleanup
+       # clean test files and directories
+       rm -rf $dir_mdt0 $dir_mdt1
+}
+run_test 401 "Compound requests split and sent to their respective MDTs"
+
+mdc_change_state() # facet, MDT_pattern, activate|deactivate
+{
+       local facet=$1
+       local pattern="$2"
+       local state=$3
+       local node=$(facet_active_host $facet)
+       local mdc
+       for mdc in $(do_facet $facet "$LCTL dl | grep -E ${pattern}-mdc" |
+                       awk '{print $4}'); do
+               echo "$3 $mdc on $node"
+               do_facet $facet "$LCTL --device $mdc $state" || return 1
+       done
+}
+
+test_402() {
+       # make sure there is no running copytool
+       copytool_cleanup
+
+       # deactivate all mdc on agent1
+       mdc_change_state $SINGLEAGT "MDT000." "deactivate"
+
+       copytool_setup $SINGLEAGT
+
+       check_agent_unregistered "uuid" # match any agent
+
+       # no expected running copytool
+       search_copytools $agent && error "Copytool start should have failed"
+
+       # reactivate MDCs
+       mdc_change_state $SINGLEAGT "MDT000." "activate"
+}
+run_test 402 "Copytool start fails if all MDTs are inactive"
+
+test_403() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       # make sure there is no running copytool
+       copytool_cleanup
+
+        local agent=$(facet_active_host $SINGLEAGT)
+       local uuid=$(do_rpc_nodes $agent get_client_uuid | cut -d' ' -f2)
+
+       # deactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "MDT0001" "deactivate"
+
+       copytool_setup
+       # check the agent is registered on MDT0000, and not on MDT0001
+       check_agent_registered_by_mdt $uuid 0
+       check_agent_unregistered_by_mdt $uuid 1
+
+       # check running copytool process
+       search_copytools $agent || error "No running copytools on $agent"
+
+       # reactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "MDT0001" "activate"
+
+       # make sure the copytool is now registered to all MDTs
+       check_agent_registered $uuid
+
+       copytool_cleanup
+}
+run_test 403 "Copytool starts with inactive MDT and register on reconnect"
+
+test_404() {
+       [ $MDSCOUNT -lt 2 ] && skip "needs >= 2 MDTs" && return
+
+       copytool_setup
+
+       # create files on both MDT0000 and MDT0001
+       mkdir -p $DIR/$tdir
+
+       local dir_mdt0=$DIR/$tdir/mdt0
+       $LFS mkdir -i 0 $dir_mdt0 || error "lfs mkdir"
+
+       # create 1 file on mdt0
+       local fid1=$(make_small $dir_mdt0/$tfile)
+
+       # deactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "MDT0001" "deactivate"
+
+       # send an HSM request for files in MDT0000
+       $LFS hsm_archive $dir_mdt0/$tfile || error "lfs hsm_archive"
+
+       # check for completion of files in MDT0000
+       wait_request_state $fid1 ARCHIVE SUCCEED 0 &&
+               echo "archive successful on mdt0"
+
+       # reactivate all mdc for MDT0001
+       mdc_change_state $SINGLEAGT "MDT0001" "activate"
+
+       copytool_cleanup
+       # clean test files and directories
+       rm -rf $dir_mdt0
+}
+run_test 404 "Inactive MDT does not block requests for active MDTs"
+
 copytool_cleanup
 
 complete $SECONDS